package feux.exo2Et3;

import java.util.HashSet;

public class FeuModele {

    private final HashSet<FeuListener> listeners = new HashSet<FeuListener>();
    private CouleurFeu couleurFeu = CouleurFeu.VERT;

    public CouleurFeu getCouleurFeu() {
        return couleurFeu;
    }

    public void setCouleurFeu(CouleurFeu couleurFeu) {
        this.couleurFeu = couleurFeu;
        prevenirListeners();
    }

    public void suivant() {        
        setCouleurFeu(getCouleurFeu().suivant());
    }
    
    public void addFeuListener(FeuListener listener) {
        listeners.add(listener);
    }

    public void removeFeuListener(FeuListener listener) {
        listeners.remove(listener);
    }

    private void prevenirListeners() {
        for (FeuListener listener: listeners) {
            listener.feuModifie();
        }
    }      
}
